require 'rbconfig'

module OpenGL
  @@opengl_platform = case RbConfig::CONFIG['host_os']
                      when /mswin|msys|mingw|cygwin/
                        :OPENGL_PLATFORM_WINDOWS
                      when /darwin/
                        :OPENGL_PLATFORM_MACOSX
                      when /linux/
                        :OPENGL_PLATFORM_LINUX
                      else
                        raise RuntimeError, "OpenGL : Unknown OS: #{host_os.inspect}"
                      end

  def self.get_platform()
    return @@opengl_platform
  end

end

=begin
Ruby-OpenGL : Yet another OpenGL wrapper for Ruby (and wrapper code generator)
Copyright (c) 2013-2021 vaiorabbit <http://twitter.com/vaiorabbit>

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
    claim that you wrote the original software. If you use this software
    in a product, an acknowledgment in the product documentation would be
    appreciated but is not required.

    2. Altered source versions must be plainly marked as such, and must not be
    misrepresented as being the original software.

    3. This notice may not be removed or altered from any source
    distribution.
=end
